unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, CommCtrl, StrUtils, ComCtrls;

type
  TfrmMain = class(TForm)
    btnInverse: TButton;
    btnConnect: TButton;
    lstProdList: TListBox;
    btnSelDown: TButton;
    btnMoveUp: TButton;
    btnMoveDown: TButton;
    lstvWindows: TListView;
    edListCount: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    btnSelUp: TButton;
    Label3: TLabel;
    procedure btnInverseClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnSelDownClick(Sender: TObject);
    procedure btnMoveUpClick(Sender: TObject);
    procedure btnMoveDownClick(Sender: TObject);
    procedure btnSelUpClick(Sender: TObject);
  private
    procedure GetProdList;
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

  hWin,
  hListBox,
  hBtnUp,
  hBtnDown : Hwnd;

implementation

{$R *.dfm}
//******************************************************************************
//** EnumProc
//** Hier werden alle Childwindows durchlaufen. Wir greifen uns die ntigen
//** Steuerelemente(Buttons, Listbox) ab, die wir brauchen
//******************************************************************************
function EnumProc(wnd: HWND; Lines : TStrings) : BOOL; stdcall;
var
  iLen      : integer;
  sClass,
  sText     : string;
  aDwordvar : DWORD;
begin
    result := true;

    // Text
    iLen := SendMessage(wnd, WM_GETTEXTLENGTH, 0, 0);
    SetLength(sText, iLen+1);
    SendMessage(wnd, WM_GETTEXT, iLen+1, Integer(PChar(sText)));

    // Klasse
    SetLength(sClass, 256);
    iLen := GetClassName(wnd, PChar(sClass), Length(sClass));
    sClass := LeftStr(sClass,iLen);

    // Steuerzeichen in der Zeichenkette entfernen
    sText  := Trim(sText);
    sClass := Trim(sClass);

    // Handle, Text, Klassenname in Listview eintragen
    With frmMain.lstvWindows.Items.Add do
    begin
        Caption := inttostr(wnd);
        SubItems.Add(sText);
        SubItems.Add(sClass);
    end;

    // Merken der Handles fr Button und ListBox
    if (sText = 'ListProd') and (sClass = 'ListBox') then hListBox := wnd
    else if (sText = 'Nach oben verschieben') and (sClass = 'Button') then hBtnUp := wnd
    else if (sText = 'Nach unten verschieben') and (sClass = 'Button') then hBtnDown := wnd;
end;


//******************************************************************************
//** Button Connect
//** Aufruf der Funktionen zur Fenstersuche und Strukturbaums
//**
//******************************************************************************
procedure TfrmMain.btnConnectClick(Sender: TObject);
begin
    // Handle des Hauptfenster
    hWin := FindWindow(nil,'Neuordnung des Grafikstrukturbaums');

    // Childwindows im Hauptfenster
    EnumChildWindows(hWin,@EnumProc, 0);

    // Anzahl der Produkte/Parts...
    edListCount.Text := IntToStr(SendMessage(hListBox,LB_GETCOUNT,0,0));

    // bertragen der Listeneintrge(Produkte/Parts) in eigene ListBox
    GetProdList;
end;


//******************************************************************************
//** GetProdList
//** Funktion zum bertragen der Listeneintrge(Produkte/Parts) in eigene ListBox
//**
//******************************************************************************
procedure TfrmMain.GetProdList;
var
    i : integer;
    s : string;
begin
    for i := 0 to strtoint(edListCount.Text)-1 do
    begin
        setlength(s,64);
        SetLength(s,SendMessage(hListBox,LB_GETTEXT,i,lParam(PChar(s))));
        lstProdList.Items.Add(s);
    end;
end;

//******************************************************************************
//** Button btnSelDown, btnSelUp, btnMoveDown, btnMoveUp
//** Steuerung der Buttons
//**
//******************************************************************************
procedure TfrmMain.btnSelDownClick(Sender: TObject);
begin
    SendMessage(hListBox,WM_KEYDOWN,VK_DOWN,0);
end;

procedure TfrmMain.btnMoveUpClick(Sender: TObject);
begin
    SendMessage(hBtnUp,BM_CLICK,0,0);
end;

procedure TfrmMain.btnMoveDownClick(Sender: TObject);
begin
    SendMessage(hBtnDown,BM_CLICK,0,0);
end;

procedure TfrmMain.btnSelUpClick(Sender: TObject);
begin
    SendMessage(hListBox,WM_KEYDOWN,VK_UP,0);
end;

//******************************************************************************
//** Button btnInverse
//** Einfaches Beispiel zum Invertieren des Strukturbaums
//**
//******************************************************************************
procedure TfrmMain.btnInverseClick(Sender: TObject);
var
    i,c : integer;
begin
    for i := strtoint(edListCount.Text)-1 downto 1 do
    begin
        for c := 1 to i do
        begin
            SendMessage(hBtnDown,BM_CLICK,0,0);
            //  Sleep(200);
        end;

        for c := 1 to i do
        begin
            SendMessage(hListBox,WM_KEYDOWN,VK_UP,0);
            //  Sleep(200);
        end;
    end;
end;

end.
